'use strict';

var fire = require('fire');
var app = fire.app('simple-chat', {modules:['ngRoute']});

// The chat controller.
function ChatController(ChatChannel, MessageModel, $scope) {
	// Lists all messages.
	$scope.messages = [];

	// We retrieve all messages stored in our database.
	MessageModel.find({}, {orderBy: 'createdAt'})
		.then(function(messages) {
			$scope.messages = messages;
		});

	// We subscribe to the main-room channel and receive all new messages.
	var channel = ChatChannel.get('main-room');
	channel.getMessage(function(message) {
		$scope.messages.push(message);
	});

	// Creates a message. See the index.html template.
	$scope.createMessage = function(text) {
		return MessageModel.create({text: text})
			.then(function() {
				$scope.text = '';
			});
	};
}
app.controller(ChatController);

// This is our main view: /.
//
// By declaring a method like this we automatically create a route in express and we create a route in $locationProvider.
ChatController.prototype.view = function() {
	return this.template('index.html');
};

// The message model.
function Message() {
	this.createdAt = [this.DateTime, this.Default('CURRENT_TIMESTAMP')];
	this.text = [this.String];
}
app.model(Message);

// After a message model is created, it's send over the channel, back to all the subscribers.
Message.prototype.afterCreate = function() {
	var chatChannel = this.channels.ChatChannel.get('main-room');
	return chatChannel.sendMessage(this);
};

// Our channel where all messages are send over.
function ChatChannel() {
	//
}
app.channel(ChatChannel);

// 
ChatChannel.prototype.getMessage = function(messageMap, webSocket) {
	//
};

ChatChannel.prototype.canSubscribe = function(user) {
	// Everyone can subscribe to this channel.
	return true;
};

app.start();
